Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_eiv.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_eiv.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traadv_eiv.F90	(revision 2528)
@@ -2,12 +2,12 @@
    !!======================================================================
    !!                    ***  MODULE  traadv_eiv  ***
-   !! Ocean active tracers:  advection trend - eddy induced velocity
+   !! Ocean tracers:  advection trend - eddy induced velocity
    !!======================================================================
-   !! History :  9.0  !  05-11  (G. Madec)  Original code, from traldf and zdf _iso
+   !! History :  1.0  !  2005-11 (G. Madec)  Original code, from traldf and zdf _iso
+   !!            3.3  !  2010-05 (C. Ethe, G. Madec)  merge TRC-TRA 
    !!----------------------------------------------------------------------
 #if defined key_traldf_eiv   ||   defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_traldf_eiv'                  rotation of the lateral mixing tensor
-   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   tra_ldf_iso : update the tracer trend with the horizontal component
@@ -21,4 +21,5 @@
    USE in_out_manager  ! I/O manager
    USE iom
+   USE trc_oce         ! share passive tracers/Ocean variables
 # if defined key_diaeiv
    USE phycst          ! physical constants
@@ -38,12 +39,12 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2006) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE tra_adv_eiv( kt, pun, pvn, pwn )
+   SUBROUTINE tra_adv_eiv( kt, pun, pvn, pwn, cdtype )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_adv_eiv  ***
@@ -63,30 +64,36 @@
       !! ** Action  : - add to p.n the eiv component
       !!----------------------------------------------------------------------
-      INTEGER , INTENT(in   )                         ::   kt    ! ocean time-step index
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pun   ! in : 3 ocean velocity components 
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pvn   ! out: 3 ocean velocity components
-      REAL(wp), INTENT(inout), DIMENSION(jpi,jpj,jpk) ::   pwn   !      increased by the eiv
+      INTEGER                         , INTENT(in   ) ::   kt       ! ocean time-step index
+      CHARACTER(len=3)                , INTENT(in   ) ::   cdtype   ! =TRA or TRC (tracer indicator)
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pun      ! in : 3 ocean velocity components 
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pvn      ! out: 3 ocean velocity components
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   pwn      ! increased by the eiv
       !!
       INTEGER  ::   ji, jj, jk                 ! dummy loop indices
-      REAL(wp) ::   zuwk, zuwk1, zuwi, zuwi1   ! temporary scalar
-      REAL(wp) ::   zvwk, zvwk1, zvwj, zvwj1   !    "         "
-      REAL(wp) ::   zu_eiv, zv_eiv, zw_eiv     !    "         "
-# if defined key_diaeiv
-      REAL(wp) ::   zztmp                      !    "         "
-      REAL(wp), DIMENSION(jpi,jpj) ::   z2d    !    "         "
+      REAL(wp) ::   zuwk, zuwk1, zuwi, zuwi1   ! local scalars
+      REAL(wp) ::   zvwk, zvwk1, zvwj, zvwj1   !   -      -
+      REAL(wp), DIMENSION(jpi,jpj) ::   zu_eiv, zv_eiv, zw_eiv     ! 2D workspace
+# if defined key_diaeiv 
+      REAL(wp) ::   zztmp                      ! local scalar
+      REAL(wp), DIMENSION(jpi,jpj) ::   z2d    ! 2D workspace
 # endif  
       !!----------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
+      IF( kt == nit000 )  THEN
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_adv_eiv : eddy induced advection :'
+         IF(lwp) WRITE(numout,*) 'tra_adv_eiv : eddy induced advection on ', cdtype,' :'
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~   add to velocity fields the eiv component'
-# if defined key_diaeiv
-         u_eiv(:,:,:) = 0.e0
-         v_eiv(:,:,:) = 0.e0
-         w_eiv(:,:,:) = 0.e0
+# if defined key_diaeiv 
+         IF( cdtype == 'TRA') THEN
+            u_eiv(:,:,:) = 0.e0
+            v_eiv(:,:,:) = 0.e0
+            w_eiv(:,:,:) = 0.e0
+         END IF
 # endif
       ENDIF
-      !                                             ! =================
+
+      zu_eiv(:,:) = 0.e0   ;   zv_eiv(:,:) = 0.e0   ;    zw_eiv(:,:) = 0.e0  
+      
+                                                    ! =================
       DO jk = 1, jpkm1                              !  Horizontal slab
          !                                          ! =================
@@ -98,15 +105,17 @@
                zvwk1= ( wslpj(ji,jj,jk+1) + wslpj(ji,jj+1,jk+1) ) * fsaeiv(ji,jj,jk+1) * vmask(ji,jj,jk+1)
 
-               zu_eiv = 0.5 * umask(ji,jj,jk) * ( zuwk - zuwk1 ) / fse3u(ji,jj,jk)
-               zv_eiv = 0.5 * vmask(ji,jj,jk) * ( zvwk - zvwk1 ) / fse3v(ji,jj,jk)
+               zu_eiv(ji,jj) = 0.5 * umask(ji,jj,jk) * ( zuwk - zuwk1 ) 
+               zv_eiv(ji,jj) = 0.5 * vmask(ji,jj,jk) * ( zvwk - zvwk1 ) 
    
-               pun(ji,jj,jk) = pun(ji,jj,jk) + zu_eiv
-               pvn(ji,jj,jk) = pvn(ji,jj,jk) + zv_eiv
-# if defined key_diaeiv
-               u_eiv(ji,jj,jk) = zu_eiv
-               v_eiv(ji,jj,jk) = zv_eiv
-# endif
+               pun(ji,jj,jk) = pun(ji,jj,jk) + e2u(ji,jj) * zu_eiv(ji,jj)
+               pvn(ji,jj,jk) = pvn(ji,jj,jk) + e1v(ji,jj) * zv_eiv(ji,jj)
             END DO
          END DO
+# if defined key_diaeiv 
+         IF( cdtype == 'TRA') THEN
+            u_eiv(:,:,jk) = zu_eiv(:,:) / fse3u(:,:,jk)
+            v_eiv(:,:,jk) = zv_eiv(:,:) / fse3v(:,:,jk)
+         END IF
+# endif
          IF( jk >=2 ) THEN                             ! jk=1 zw_eiv=0, not computed
             DO jj = 2, jpjm1
@@ -118,5 +127,5 @@
                   zvwj1 = ( wslpj(ji,jj,jk)+wslpj(ji,jj+1,jk) ) * fsaeiv(ji,jj  ,jk) * e1v(ji  ,jj) * vmask(ji  ,jj,jk)
   
-                  zw_eiv = - 0.5 * tmask(ji,jj,jk) * ( zuwi1 - zuwi + zvwj1 - zvwj ) / ( e1t(ji,jj)*e2t(ji,jj) )
+                  zw_eiv(ji,jj) = - 0.5 * tmask(ji,jj,jk) * ( zuwi1 - zuwi + zvwj1 - zvwj ) 
 # else
                   zuwi  = ( wslpi(ji,jj,jk) + wslpi(ji-1,jj,jk) ) * e2u(ji-1,jj) * umask(ji-1,jj,jk)
@@ -125,14 +134,12 @@
                   zvwj1 = ( wslpj(ji,jj,jk) + wslpj(ji,jj+1,jk) ) * e1v(ji  ,jj) * vmask(ji  ,jj,jk)
 
-                  zw_eiv = - 0.5 * tmask(ji,jj,jk) * fsaeiw(ji,jj,jk) * ( zuwi1 - zuwi + zvwj1 - zvwj )  &
-                     &                                                / ( e1t(ji,jj)*e2t(ji,jj) )
+                  zw_eiv(ji,jj) = - 0.5 * tmask(ji,jj,jk) * fsaeiw(ji,jj,jk) * ( zuwi1 - zuwi + zvwj1 - zvwj )
 # endif
-                  pwn(ji,jj,jk) = pwn(ji,jj,jk) + zw_eiv
-
-# if defined key_diaeiv
-                  w_eiv(ji,jj,jk) = zw_eiv
-# endif
+                  pwn(ji,jj,jk) = pwn(ji,jj,jk) + zw_eiv(ji,jj)
                END DO
             END DO
+# if defined key_diaeiv 
+            IF( cdtype == 'TRA')  w_eiv(:,:,jk) = zw_eiv(:,:) / ( e1t(:,:) * e2t(:,:) )
+# endif
          ENDIF
          !                                          ! =================
@@ -140,31 +147,35 @@
       !                                             ! =================
 
-# if defined key_diaeiv
-      CALL iom_put( "uoce_eiv", u_eiv )    ! i-eiv current
-      CALL iom_put( "voce_eiv", v_eiv )    ! j-eiv current
-      CALL iom_put( "woce_eiv", w_eiv )    ! vert. eiv current
-      IF( lk_diaar5 ) THEN
-         zztmp = 0.5 * rau0 * rcp 
-         z2d(:,:) = 0.e0 
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  z2d(ji,jj) = z2d(ji,jj) + zztmp * u_eiv(ji,jj,jk) * (tn(ji,jj,jk)+tn(ji+1,jj,jk)) * e1u(ji,jj) * fse3u(ji,jj,jk) 
+# if defined key_diaeiv 
+      IF( cdtype == 'TRA') THEN
+         CALL iom_put( "uoce_eiv", u_eiv )    ! i-eiv current
+         CALL iom_put( "voce_eiv", v_eiv )    ! j-eiv current
+         CALL iom_put( "woce_eiv", w_eiv )    ! vert. eiv current
+         IF( lk_diaar5 ) THEN
+            zztmp = 0.5 * rau0 * rcp 
+            z2d(:,:) = 0.e0 
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     z2d(ji,jj) = z2d(ji,jj) + zztmp * u_eiv(ji,jj,jk) &
+                       &         * (tsn(ji,jj,jk,jp_tem)+tsn(ji+1,jj,jk,jp_tem)) * e1u(ji,jj) * fse3u(ji,jj,jk) 
+                  END DO
                END DO
             END DO
-         END DO
-         CALL lbc_lnk( z2d, 'U', -1. )
-         CALL iom_put( "ueiv_heattr", z2d )                  ! heat transport in i-direction
-         z2d(:,:) = 0.e0 
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  z2d(ji,jj) = z2d(ji,jj) + zztmp * v_eiv(ji,jj,jk) * (tn(ji,jj,jk)+tn(ji,jj+1,jk)) * e2v(ji,jj) * fse3v(ji,jj,jk) 
+            CALL lbc_lnk( z2d, 'U', -1. )
+            CALL iom_put( "ueiv_heattr", z2d )                  ! heat transport in i-direction
+            z2d(:,:) = 0.e0 
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     z2d(ji,jj) = z2d(ji,jj) + zztmp * v_eiv(ji,jj,jk) &
+                     &           * (tsn(ji,jj,jk,jp_tem)+tsn(ji,jj+1,jk,jp_tem)) * e2v(ji,jj) * fse3v(ji,jj,jk) 
+                  END DO
                END DO
             END DO
-         END DO
-         CALL lbc_lnk( z2d, 'V', -1. )
-         CALL iom_put( "veiv_heattr", z2d )                  !  heat transport in i-direction
-      ENDIF
+            CALL lbc_lnk( z2d, 'V', -1. )
+            CALL iom_put( "veiv_heattr", z2d )                  !  heat transport in i-direction
+         ENDIF
+    END IF
 # endif  
       ! 
@@ -176,7 +187,10 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE tra_adv_eiv( kt, pun, pvn, pwn )              ! Empty routine
+   SUBROUTINE tra_adv_eiv( kt, pun, pvn, pwn, cdtype )              ! Empty routine
+      INTEGER  ::   kt    
+      CHARACTER(len=3) ::   cdtype
       REAL, DIMENSION(:,:,:) ::   pun, pvn, pwn
-      WRITE(*,*) 'tra_adv_eiv: You should not have seen this print! error?', kt, pun(1,1,1), pvn(1,1,1), pwn(1,1,1)
+      WRITE(*,*) 'tra_adv_eiv: You should not have seen this print! error?', kt, cdtype
+      WRITE(*,*) 'tra_adv_eiv: You should not have seen this print! error?', pun(1,1,1), pvn(1,1,1), pwn(1,1,1)
    END SUBROUTINE tra_adv_eiv
 #endif
